/*
** list_add_item_sorted.c for list in /u/a1/deleda_c/rendu/piscine/j6/list
**
** Made by charles-alban deledalle
** Login   <deleda_c@epita.fr>
**
** Started on  Fri Sep 16 23:55:21 2005 charles-alban deledalle
** Last update Sat Sep 17 04:03:25 2005 charles-alban deledalle
*/

#include <stdlib.h>
#include "s_list.h"

static struct s_list	*list_create_node_ais(void	*data)
{
  struct s_list		*res;

  if (!(res = malloc(sizeof (struct s_list))))
    exit(42);
  res->data = data;
  res->next = NULL;
  return res;
}

void		list_add_item_sorted(struct s_list	**list,
				     void		*data,
				     t_cmp_func		cmp_func)
{
  struct s_list	*tmp;

  if (!(*list))
    *list = list_create_node_ais(data);
  else
    {
      if (cmp_func((*list)->data, data) == 0)
      	return;
      if (cmp_func((*list)->data, data) > 0)
      {
	tmp = list_create_node_ais(data);
	tmp->next = *list;
	*list = tmp;
      }
      else
	list_add_item_sorted(&((*list)->next),
			     data,
			     cmp_func);
    }
}
